Sixth batch for 2.12
[git/debian.git] / git-submodule.sh
blob554bd1c4943a5f2dd9aa9615dadc962bf6405d7a
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16 OPTIONS_SPEC=
17 SUBDIRECTORY_OK=Yes
18 . git-sh-setup
19 . git-parse-remote
20 require_work_tree
21 wt_prefix=$(git rev-parse --show-prefix)
22 cd_to_toplevel
24 # Tell the rest of git that any URLs we get don't come
25 # directly from the user, so it can apply policy as appropriate.
26 GIT_PROTOCOL_FROM_USER=0
27 export GIT_PROTOCOL_FROM_USER
29 command=
30 branch=
31 force=
32 reference=
33 cached=
34 recursive=
35 init=
36 files=
37 remote=
38 nofetch=
39 update=
40 prefix=
41 custom_name=
42 depth=
43 progress=
45 die_if_unmatched ()
47 if test "$1" = "#unmatched"
48 then
49 exit ${2:-1}
54 # Print a submodule configuration setting
56 # $1 = submodule name
57 # $2 = option name
58 # $3 = default value
60 # Checks in the usual git-config places first (for overrides),
61 # otherwise it falls back on .gitmodules. This allows you to
62 # distribute project-wide defaults in .gitmodules, while still
63 # customizing individual repositories if necessary. If the option is
64 # not in .gitmodules either, print a default value.
66 get_submodule_config () {
67 name="$1"
68 option="$2"
69 default="$3"
70 value=$(git config submodule."$name"."$option")
71 if test -z "$value"
72 then
73 value=$(git config -f .gitmodules submodule."$name"."$option")
75 printf '%s' "${value:-$default}"
78 isnumber()
80 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
83 # Sanitize the local git environment for use within a submodule. We
84 # can't simply use clear_local_git_env since we want to preserve some
85 # of the settings from GIT_CONFIG_PARAMETERS.
86 sanitize_submodule_env()
88 save_config=$GIT_CONFIG_PARAMETERS
89 clear_local_git_env
90 GIT_CONFIG_PARAMETERS=$save_config
91 export GIT_CONFIG_PARAMETERS
95 # Add a new submodule to the working tree, .gitmodules and the index
97 # $@ = repo path
99 # optional branch is stored in global branch variable
101 cmd_add()
103 # parse $args after "submodule ... add".
104 reference_path=
105 while test $# -ne 0
107 case "$1" in
108 -b | --branch)
109 case "$2" in '') usage ;; esac
110 branch=$2
111 shift
113 -f | --force)
114 force=$1
116 -q|--quiet)
117 GIT_QUIET=1
119 --reference)
120 case "$2" in '') usage ;; esac
121 reference_path=$2
122 shift
124 --reference=*)
125 reference_path="${1#--reference=}"
127 --name)
128 case "$2" in '') usage ;; esac
129 custom_name=$2
130 shift
132 --depth)
133 case "$2" in '') usage ;; esac
134 depth="--depth=$2"
135 shift
137 --depth=*)
138 depth=$1
141 shift
142 break
145 usage
148 break
150 esac
151 shift
152 done
154 if test -n "$reference_path"
155 then
156 is_absolute_path "$reference_path" ||
157 reference_path="$wt_prefix$reference_path"
159 reference="--reference=$reference_path"
162 repo=$1
163 sm_path=$2
165 if test -z "$sm_path"; then
166 sm_path=$(printf '%s\n' "$repo" |
167 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
170 if test -z "$repo" || test -z "$sm_path"; then
171 usage
174 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
176 # assure repo is absolute or relative to parent
177 case "$repo" in
178 ./*|../*)
179 test -z "$wt_prefix" ||
180 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
182 # dereference source url relative to parent's url
183 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
185 *:*|/*)
186 # absolute url
187 realrepo=$repo
190 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
192 esac
194 # normalize path:
195 # multiple //; leading ./; /./; /../; trailing /
196 sm_path=$(printf '%s/\n' "$sm_path" |
197 sed -e '
198 s|//*|/|g
199 s|^\(\./\)*||
200 s|/\(\./\)*|/|g
201 :start
202 s|\([^/]*\)/\.\./||
203 tstart
204 s|/*$||
206 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
207 die "$(eval_gettext "'\$sm_path' already exists in the index")"
209 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
210 then
211 eval_gettextln "The following path is ignored by one of your .gitignore files:
212 \$sm_path
213 Use -f if you really want to add it." >&2
214 exit 1
217 if test -n "$custom_name"
218 then
219 sm_name="$custom_name"
220 else
221 sm_name="$sm_path"
224 # perhaps the path exists and is already a git repo, else clone it
225 if test -e "$sm_path"
226 then
227 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
228 then
229 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
230 else
231 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
234 else
235 if test -d ".git/modules/$sm_name"
236 then
237 if test -z "$force"
238 then
239 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
240 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
241 die "$(eval_gettextln "\
242 If you want to reuse this local git directory instead of cloning again from
243 \$realrepo
244 use the '--force' option. If the local git directory is not the correct repo
245 or you are unsure what this means choose another name with the '--name' option.")"
246 else
247 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
250 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
252 sanitize_submodule_env
253 cd "$sm_path" &&
254 # ash fails to wordsplit ${branch:+-b "$branch"...}
255 case "$branch" in
256 '') git checkout -f -q ;;
257 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
258 esac
259 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
261 git config submodule."$sm_name".url "$realrepo"
263 git add $force "$sm_path" ||
264 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
266 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
267 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
268 if test -n "$branch"
269 then
270 git config -f .gitmodules submodule."$sm_name".branch "$branch"
271 fi &&
272 git add --force .gitmodules ||
273 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
277 # Execute an arbitrary command sequence in each checked out
278 # submodule
280 # $@ = command to execute
282 cmd_foreach()
284 # parse $args after "submodule ... foreach".
285 while test $# -ne 0
287 case "$1" in
288 -q|--quiet)
289 GIT_QUIET=1
291 --recursive)
292 recursive=1
295 usage
298 break
300 esac
301 shift
302 done
304 toplevel=$(pwd)
306 # dup stdin so that it can be restored when running the external
307 # command in the subshell (and a recursive call to this function)
308 exec 3<&0
311 git submodule--helper list --prefix "$wt_prefix" ||
312 echo "#unmatched" $?
314 while read mode sha1 stage sm_path
316 die_if_unmatched "$mode" "$sha1"
317 if test -e "$sm_path"/.git
318 then
319 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
320 say "$(eval_gettext "Entering '\$displaypath'")"
321 name=$(git submodule--helper name "$sm_path")
323 prefix="$prefix$sm_path/"
324 sanitize_submodule_env
325 cd "$sm_path" &&
326 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
327 # we make $path available to scripts ...
328 path=$sm_path &&
329 if test $# -eq 1
330 then
331 eval "$1"
332 else
333 "$@"
334 fi &&
335 if test -n "$recursive"
336 then
337 cmd_foreach "--recursive" "$@"
339 ) <&3 3<&- ||
340 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
342 done
346 # Register submodules in .git/config
348 # $@ = requested paths (default to all)
350 cmd_init()
352 # parse $args after "submodule ... init".
353 while test $# -ne 0
355 case "$1" in
356 -q|--quiet)
357 GIT_QUIET=1
360 shift
361 break
364 usage
367 break
369 esac
370 shift
371 done
373 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
377 # Unregister submodules from .git/config and remove their work tree
379 cmd_deinit()
381 # parse $args after "submodule ... deinit".
382 deinit_all=
383 while test $# -ne 0
385 case "$1" in
386 -f|--force)
387 force=$1
389 -q|--quiet)
390 GIT_QUIET=1
392 --all)
393 deinit_all=t
396 shift
397 break
400 usage
403 break
405 esac
406 shift
407 done
409 if test -n "$deinit_all" && test "$#" -ne 0
410 then
411 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
412 usage
414 if test $# = 0 && test -z "$deinit_all"
415 then
416 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
420 git submodule--helper list --prefix "$wt_prefix" "$@" ||
421 echo "#unmatched" $?
423 while read mode sha1 stage sm_path
425 die_if_unmatched "$mode" "$sha1"
426 name=$(git submodule--helper name "$sm_path") || exit
428 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
430 # Remove the submodule work tree (unless the user already did it)
431 if test -d "$sm_path"
432 then
433 # Protect submodules containing a .git directory
434 if test -d "$sm_path/.git"
435 then
436 die "$(eval_gettext "\
437 Submodule work tree '\$displaypath' contains a .git directory
438 (use 'rm -rf' if you really want to remove it including all of its history)")"
441 if test -z "$force"
442 then
443 git rm -qn "$sm_path" ||
444 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
446 rm -rf "$sm_path" &&
447 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
448 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
451 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
453 # Remove the .git/config entries (unless the user already did it)
454 if test -n "$(git config --get-regexp submodule."$name\.")"
455 then
456 # Remove the whole section so we have a clean state when
457 # the user later decides to init this submodule again
458 url=$(git config submodule."$name".url)
459 git config --remove-section submodule."$name" 2>/dev/null &&
460 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
462 done
465 is_tip_reachable () (
466 sanitize_submodule_env &&
467 cd "$1" &&
468 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
469 test -z "$rev"
472 fetch_in_submodule () (
473 sanitize_submodule_env &&
474 cd "$1" &&
475 case "$2" in
477 git fetch ;;
479 shift
480 git fetch $(get_default_remote) "$@" ;;
481 esac
485 # Update each submodule path to correct revision, using clone and checkout as needed
487 # $@ = requested paths (default to all)
489 cmd_update()
491 # parse $args after "submodule ... update".
492 while test $# -ne 0
494 case "$1" in
495 -q|--quiet)
496 GIT_QUIET=1
498 --progress)
499 progress="--progress"
501 -i|--init)
502 init=1
504 --remote)
505 remote=1
507 -N|--no-fetch)
508 nofetch=1
510 -f|--force)
511 force=$1
513 -r|--rebase)
514 update="rebase"
516 --reference)
517 case "$2" in '') usage ;; esac
518 reference="--reference=$2"
519 shift
521 --reference=*)
522 reference="$1"
524 -m|--merge)
525 update="merge"
527 --recursive)
528 recursive=1
530 --checkout)
531 update="checkout"
533 --recommend-shallow)
534 recommend_shallow="--recommend-shallow"
536 --no-recommend-shallow)
537 recommend_shallow="--no-recommend-shallow"
539 --depth)
540 case "$2" in '') usage ;; esac
541 depth="--depth=$2"
542 shift
544 --depth=*)
545 depth=$1
547 -j|--jobs)
548 case "$2" in '') usage ;; esac
549 jobs="--jobs=$2"
550 shift
552 --jobs=*)
553 jobs=$1
556 shift
557 break
560 usage
563 break
565 esac
566 shift
567 done
569 if test -n "$init"
570 then
571 cmd_init "--" "$@" || return
575 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
576 ${progress:+"$progress"} \
577 ${wt_prefix:+--prefix "$wt_prefix"} \
578 ${prefix:+--recursive-prefix "$prefix"} \
579 ${update:+--update "$update"} \
580 ${reference:+"$reference"} \
581 ${depth:+--depth "$depth"} \
582 ${recommend_shallow:+"$recommend_shallow"} \
583 ${jobs:+$jobs} \
584 "$@" || echo "#unmatched" $?
585 } | {
586 err=
587 while read mode sha1 stage just_cloned sm_path
589 die_if_unmatched "$mode" "$sha1"
591 name=$(git submodule--helper name "$sm_path") || exit
592 url=$(git config submodule."$name".url)
593 if ! test -z "$update"
594 then
595 update_module=$update
596 else
597 update_module=$(git config submodule."$name".update)
598 if test -z "$update_module"
599 then
600 update_module="checkout"
604 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
606 if test $just_cloned -eq 1
607 then
608 subsha1=
609 update_module=checkout
610 else
611 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
612 git rev-parse --verify HEAD) ||
613 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
616 if test -n "$remote"
617 then
618 branch=$(git submodule--helper remote-branch "$sm_path")
619 if test -z "$nofetch"
620 then
621 # Fetch remote before determining tracking $sha1
622 fetch_in_submodule "$sm_path" $depth ||
623 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
625 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
626 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
627 git rev-parse --verify "${remote_name}/${branch}") ||
628 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
631 if test "$subsha1" != "$sha1" || test -n "$force"
632 then
633 subforce=$force
634 # If we don't already have a -f flag and the submodule has never been checked out
635 if test -z "$subsha1" && test -z "$force"
636 then
637 subforce="-f"
640 if test -z "$nofetch"
641 then
642 # Run fetch only if $sha1 isn't present or it
643 # is not reachable from a ref.
644 is_tip_reachable "$sm_path" "$sha1" ||
645 fetch_in_submodule "$sm_path" $depth ||
646 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
648 # Now we tried the usual fetch, but $sha1 may
649 # not be reachable from any of the refs
650 is_tip_reachable "$sm_path" "$sha1" ||
651 fetch_in_submodule "$sm_path" $depth "$sha1" ||
652 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
655 must_die_on_failure=
656 case "$update_module" in
657 checkout)
658 command="git checkout $subforce -q"
659 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
660 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
662 rebase)
663 command="git rebase"
664 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
665 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
666 must_die_on_failure=yes
668 merge)
669 command="git merge"
670 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
671 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
672 must_die_on_failure=yes
675 command="${update_module#!}"
676 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
677 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
678 must_die_on_failure=yes
681 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
682 esac
684 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
685 then
686 say "$say_msg"
687 elif test -n "$must_die_on_failure"
688 then
689 die_with_status 2 "$die_msg"
690 else
691 err="${err};$die_msg"
692 continue
696 if test -n "$recursive"
697 then
699 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
700 wt_prefix=
701 sanitize_submodule_env
702 cd "$sm_path" &&
703 eval cmd_update
705 res=$?
706 if test $res -gt 0
707 then
708 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
709 if test $res -ne 2
710 then
711 err="${err};$die_msg"
712 continue
713 else
714 die_with_status $res "$die_msg"
718 done
720 if test -n "$err"
721 then
722 OIFS=$IFS
723 IFS=';'
724 for e in $err
726 if test -n "$e"
727 then
728 echo >&2 "$e"
730 done
731 IFS=$OIFS
732 exit 1
737 set_name_rev () {
738 revname=$( (
739 sanitize_submodule_env
740 cd "$1" && {
741 git describe "$2" 2>/dev/null ||
742 git describe --tags "$2" 2>/dev/null ||
743 git describe --contains "$2" 2>/dev/null ||
744 git describe --all --always "$2"
747 test -z "$revname" || revname=" ($revname)"
750 # Show commit summary for submodules in index or working tree
752 # If '--cached' is given, show summary between index and given commit,
753 # or between working tree and given commit
755 # $@ = [commit (default 'HEAD'),] requested paths (default all)
757 cmd_summary() {
758 summary_limit=-1
759 for_status=
760 diff_cmd=diff-index
762 # parse $args after "submodule ... summary".
763 while test $# -ne 0
765 case "$1" in
766 --cached)
767 cached="$1"
769 --files)
770 files="$1"
772 --for-status)
773 for_status="$1"
775 -n|--summary-limit)
776 summary_limit="$2"
777 isnumber "$summary_limit" || usage
778 shift
780 --summary-limit=*)
781 summary_limit="${1#--summary-limit=}"
782 isnumber "$summary_limit" || usage
785 shift
786 break
789 usage
792 break
794 esac
795 shift
796 done
798 test $summary_limit = 0 && return
800 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
801 then
802 head=$rev
803 test $# = 0 || shift
804 elif test -z "$1" || test "$1" = "HEAD"
805 then
806 # before the first commit: compare with an empty tree
807 head=$(git hash-object -w -t tree --stdin </dev/null)
808 test -z "$1" || shift
809 else
810 head="HEAD"
813 if [ -n "$files" ]
814 then
815 test -n "$cached" &&
816 die "$(gettext "The --cached option cannot be used with the --files option")"
817 diff_cmd=diff-files
818 head=
821 cd_to_toplevel
822 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
823 # Get modified modules cared by user
824 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
825 sane_egrep '^:([0-7]* )?160000' |
826 while read mod_src mod_dst sha1_src sha1_dst status sm_path
828 # Always show modules deleted or type-changed (blob<->module)
829 if test "$status" = D || test "$status" = T
830 then
831 printf '%s\n' "$sm_path"
832 continue
834 # Respect the ignore setting for --for-status.
835 if test -n "$for_status"
836 then
837 name=$(git submodule--helper name "$sm_path")
838 ignore_config=$(get_submodule_config "$name" ignore none)
839 test $status != A && test $ignore_config = all && continue
841 # Also show added or modified modules which are checked out
842 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
843 printf '%s\n' "$sm_path"
844 done
847 test -z "$modules" && return
849 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
850 sane_egrep '^:([0-7]* )?160000' |
851 cut -c2- |
852 while read mod_src mod_dst sha1_src sha1_dst status name
854 if test -z "$cached" &&
855 test $sha1_dst = 0000000000000000000000000000000000000000
856 then
857 case "$mod_dst" in
858 160000)
859 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
861 100644 | 100755 | 120000)
862 sha1_dst=$(git hash-object $name)
864 000000)
865 ;; # removed
867 # unexpected type
868 eval_gettextln "unexpected mode \$mod_dst" >&2
869 continue ;;
870 esac
872 missing_src=
873 missing_dst=
875 test $mod_src = 160000 &&
876 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
877 missing_src=t
879 test $mod_dst = 160000 &&
880 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
881 missing_dst=t
883 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
885 total_commits=
886 case "$missing_src,$missing_dst" in
888 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
891 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
893 t,t)
894 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
897 errmsg=
898 total_commits=$(
899 if test $mod_src = 160000 && test $mod_dst = 160000
900 then
901 range="$sha1_src...$sha1_dst"
902 elif test $mod_src = 160000
903 then
904 range=$sha1_src
905 else
906 range=$sha1_dst
908 GIT_DIR="$name/.git" \
909 git rev-list --first-parent $range -- | wc -l
911 total_commits=" ($(($total_commits + 0)))"
913 esac
915 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
916 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
917 if test $status = T
918 then
919 blob="$(gettext "blob")"
920 submodule="$(gettext "submodule")"
921 if test $mod_dst = 160000
922 then
923 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
924 else
925 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
927 else
928 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
930 if test -n "$errmsg"
931 then
932 # Don't give error msg for modification whose dst is not submodule
933 # i.e. deleted or changed to blob
934 test $mod_dst = 160000 && echo "$errmsg"
935 else
936 if test $mod_src = 160000 && test $mod_dst = 160000
937 then
938 limit=
939 test $summary_limit -gt 0 && limit="-$summary_limit"
940 GIT_DIR="$name/.git" \
941 git log $limit --pretty='format: %m %s' \
942 --first-parent $sha1_src...$sha1_dst
943 elif test $mod_dst = 160000
944 then
945 GIT_DIR="$name/.git" \
946 git log --pretty='format: > %s' -1 $sha1_dst
947 else
948 GIT_DIR="$name/.git" \
949 git log --pretty='format: < %s' -1 $sha1_src
951 echo
953 echo
954 done
957 # List all submodules, prefixed with:
958 # - submodule not initialized
959 # + different revision checked out
961 # If --cached was specified the revision in the index will be printed
962 # instead of the currently checked out revision.
964 # $@ = requested paths (default to all)
966 cmd_status()
968 # parse $args after "submodule ... status".
969 while test $# -ne 0
971 case "$1" in
972 -q|--quiet)
973 GIT_QUIET=1
975 --cached)
976 cached=1
978 --recursive)
979 recursive=1
982 shift
983 break
986 usage
989 break
991 esac
992 shift
993 done
996 git submodule--helper list --prefix "$wt_prefix" "$@" ||
997 echo "#unmatched" $?
999 while read mode sha1 stage sm_path
1001 die_if_unmatched "$mode" "$sha1"
1002 name=$(git submodule--helper name "$sm_path") || exit
1003 url=$(git config submodule."$name".url)
1004 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1005 if test "$stage" = U
1006 then
1007 say "U$sha1 $displaypath"
1008 continue
1010 if test -z "$url" ||
1012 ! test -d "$sm_path"/.git &&
1013 ! test -f "$sm_path"/.git
1015 then
1016 say "-$sha1 $displaypath"
1017 continue;
1019 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1020 then
1021 set_name_rev "$sm_path" "$sha1"
1022 say " $sha1 $displaypath$revname"
1023 else
1024 if test -z "$cached"
1025 then
1026 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1028 set_name_rev "$sm_path" "$sha1"
1029 say "+$sha1 $displaypath$revname"
1032 if test -n "$recursive"
1033 then
1035 prefix="$displaypath/"
1036 sanitize_submodule_env
1037 wt_prefix=
1038 cd "$sm_path" &&
1039 eval cmd_status
1040 ) ||
1041 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1043 done
1046 # Sync remote urls for submodules
1047 # This makes the value for remote.$remote.url match the value
1048 # specified in .gitmodules.
1050 cmd_sync()
1052 while test $# -ne 0
1054 case "$1" in
1055 -q|--quiet)
1056 GIT_QUIET=1
1057 shift
1059 --recursive)
1060 recursive=1
1061 shift
1064 shift
1065 break
1068 usage
1071 break
1073 esac
1074 done
1075 cd_to_toplevel
1077 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1078 echo "#unmatched" $?
1080 while read mode sha1 stage sm_path
1082 die_if_unmatched "$mode" "$sha1"
1083 name=$(git submodule--helper name "$sm_path")
1084 url=$(git config -f .gitmodules --get submodule."$name".url)
1086 # Possibly a url relative to parent
1087 case "$url" in
1088 ./*|../*)
1089 # rewrite foo/bar as ../.. to find path from
1090 # submodule work tree to superproject work tree
1091 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1092 # guarantee a trailing /
1093 up_path=${up_path%/}/ &&
1094 # path from submodule work tree to submodule origin repo
1095 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1096 # path from superproject work tree to submodule origin repo
1097 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1100 sub_origin_url="$url"
1101 super_config_url="$url"
1103 esac
1105 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1106 then
1107 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1108 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1109 git config submodule."$name".url "$super_config_url"
1111 if test -e "$sm_path"/.git
1112 then
1114 sanitize_submodule_env
1115 cd "$sm_path"
1116 remote=$(get_default_remote)
1117 git config remote."$remote".url "$sub_origin_url"
1119 if test -n "$recursive"
1120 then
1121 prefix="$prefix$sm_path/"
1122 eval cmd_sync
1127 done
1130 cmd_absorbgitdirs()
1132 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1135 # This loop parses the command line arguments to find the
1136 # subcommand name to dispatch. Parsing of the subcommand specific
1137 # options are primarily done by the subcommand implementations.
1138 # Subcommand specific options such as --branch and --cached are
1139 # parsed here as well, for backward compatibility.
1141 while test $# != 0 && test -z "$command"
1143 case "$1" in
1144 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1145 command=$1
1147 -q|--quiet)
1148 GIT_QUIET=1
1150 -b|--branch)
1151 case "$2" in
1153 usage
1155 esac
1156 branch="$2"; shift
1158 --cached)
1159 cached="$1"
1162 break
1165 usage
1168 break
1170 esac
1171 shift
1172 done
1174 # No command word defaults to "status"
1175 if test -z "$command"
1176 then
1177 if test $# = 0
1178 then
1179 command=status
1180 else
1181 usage
1185 # "-b branch" is accepted only by "add"
1186 if test -n "$branch" && test "$command" != add
1187 then
1188 usage
1191 # "--cached" is accepted only by "status" and "summary"
1192 if test -n "$cached" && test "$command" != status && test "$command" != summary
1193 then
1194 usage
1197 "cmd_$command" "$@"